/*
 * TestTask.cpp
 *
 *  Created on: 12.10.2015
 *      Author: Raphael Imahorn <raphael.imahorn@stud.unibas.ch>
 */

#include "TestTask.h"
#include "option_parser.h"
#include "plugin.h"
#include "utilities.h"

#include <iostream>
#include <memory>

using namespace std;

TestTask::TestTask(const Options &opts)
: DelegatingTask(opts.get<shared_ptr<AbstractTask>>("transform")){
	cout << "test" << endl;
}


static shared_ptr<AbstractTask> _parse(OptionParser &parser) {
    parser.add_option<shared_ptr<AbstractTask>>(
        "transform",
        "Parent task transformation",
        "no_transform");
    add_cost_type_option_to_parser(parser);
    Options opts = parser.parse();
    if (parser.dry_run())
        return nullptr;
    else
        return make_shared<TestTask>(opts);
}

static PluginShared<AbstractTask> _plugin("test_task", _parse);

